---
title: Clipboard.readText()
slug: Web/API/Clipboard/readText
tags:
  - API
  - Async Clipboard API
  - Clip
  - Clipboard
  - Clipboard API
  - Cut
  - Editing
  - Method
  - Pasteboard
  - Reference
  - Text
  - copy
  - paste
  - readText
---
<div>{{APIRef("Clipboard API")}}</div>

<p><span class="seoSummary">The <strong>{{domxref("Clipboard")}}</strong> interface's <strong><code>readText()</code></strong> method returns a {{jsxref("Promise")}} which resolves with a copy of the textual contents of the system clipboard.</span>. The <code>"clipboard-read"</code> permission of the <a href="/en-US/docs/Web/API/Permissions_API">Permissions API</a> must be granted before you can read data from the clipboard.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <em>promise</em> = navigator.clipboard.readText()</pre>

<h3 id="Parameters">Parameters</h3>

<p>None.</p>

<h3 id="Return_value"><span>Return value</span></h3>

<p>A {{jsxref("Promise")}} that resolves with a {{domxref("DOMString")}} containing the textual contents of the clipboard. Returns an empty string if the clipboard is empty, does not contain text, or does not include a textual representation among the {{domxref("DataTransfer")}} objects representing the clipboard's contents.</p>

<p>To read non-text contents from the clipboard, use the {{domxref("Clipboard.read", "read()")}} method instead. You can write text to the clipboard using {{domxref("Clipboard.writeText", "writeText()")}}.</p>

<h2 id="Example">Example</h2>

<p>This example retrieves the textual contents of the clipboard and inserts the returned text into an element's contents.</p>

<pre class="brush: js notranslate">navigator.clipboard.readText().then(
  clipText =&gt; document.getElementById("outbox").innerText = clipText);</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Clipboard API','#dom-clipboard-readtext','readText()')}}</td>
   <td>{{Spec2('Clipboard API')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Clipboard.readText")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Clipboard_API">Clipboard API</a></li>
 <li><a href="https://async-clipboard-api.glitch.me/">Async Clipboard API demo on Glitch</a></li>
 <li><a href="https://web.dev/image-support-for-async-clipboard/">Image support for Async Clipboard article</a></li>
 <li>{{domxref("Clipboard.writeText()")}}</li>
 <li>{{domxref("Clipboard.write()")}}</li>
</ul>
